<?xml version="1.0" encoding="ISO-8859-1"?>

<document>

    <properties>
        <author email="pnever@apache.org">Peter Nevermann</author>
        <title>DeltaV Howto</title>
    </properties>

    <body>
        <section name="Introduction">
            <p>
            Slide supports DeltaV (version control) according to the <a href="http://webdav.org/deltav">WebDAV DeltaV specification</a>.
            </p>
        </section>
      
        <section name="Enabling or disabling version control">
            <p>
            By default, version control is enabled in Slide.
            </p>
            <p>
            To disable version control, search for a configuration file named <i>slide.properties</i> in the classpath
            (if not there, you can create a new one at e.g. $CATALINA_HOME/common/classes)
            and set or add:
            <pre>org.apache.slide.versioncontrol=false</pre>
            </p>
        </section>
        
        <section name="Other parameters (Domain.xml)">
            <p>
            There are some more global parameters in the Slide configuration file <i>Domain.xml</i>, which influence the version control
            behavior of the server.
            </p>
            <p>
            <font color="red"><b>IMPORTANT NOTE:</b></font><br/>Under no circumstances the values of the following three parameters should be changed
            while there are any stores configured or data exists for any store, as no migration of the data will take place:<br/>
            <b>historypath</b>, <b>workspacepath</b>, <b>workingresourcepath</b>.
            </p>
            <ul>
            <li>
            <i>historypath</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="historypath"]</code></font>):<br/>
            Specifies a Slide path which determines the location where this DeltaV server stores history data.<br/>
            Default value is <code>/history</code>.
            </li>
            <li>
            <i>workspacepath</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="workspacepath"]</code></font>):<br/>
            Specifies a Slide path which determines the location where this DeltaV server allows workspaces to reside.<br/>
            Default value is <code>/workspace</code>.
            </li>
            <li>
            <i>workingresourcepath</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="workingresourcepath"]</code></font>):<br/>
            Specifies a Slide path which determines the location where this DeltaV server stores working resources.<br/>
            Default value is <code>/workingresource</code>.
            </li>
            <li>
            <i>versioncontrol-exclude</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="versioncontrol-exclude"]</code></font>):<br/>
            Specifies a Slide path which determines resources which are excluded from version-control.<br/>
            Default value is <code>""</code>.
            </li>
            <li>
            <i>auto-version-control</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="auto-version-control"]</code></font>):<br/>
            Indicates whether newly created resources are to be set under version-control automatically.<br/>
            Default value is <code>false</code>.
            </li>
            <li>
            <i>auto-version</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="auto-version"]</code></font>):<br/>
            Specifies the default initial value of the <i>DAV:auto-version</i> property for newly created version controlled resources.
            For the complete list the possible values refer to section 3.2.2 of the <a href="http://ietf.org/rfc/rfc3253.txt">DeltaV specification</a>.<br/>
            Default value is <code>checkout-checkin</code>.
            </li>
            <li>
            <i>checkout-fork</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="checkout-fork"]</code></font>):<br/>
            Specifies the default initial value of the <i>DAV:checkout-fork</i> property for newly created version resources.
            For the complete list the possible values refer to section 4.1.1 of the <a href="http://ietf.org/rfc/rfc3253.txt">DeltaV specification</a>.<br/>
            Default value is <code>forbidden</code>.
            </li>
            <li>
            <i>checkin-fork</i><br/> (xpath: <font color="blue"><code>/slide/parameter[@name="checkin-fork"]</code></font>):<br/>
            Specifies the default initial value of the <i>DAV:checkin-fork</i> property for newly created version resources.
            For the complete list the possible values refer to section 4.1.2 of the <a href="http://ietf.org/rfc/rfc3253.txt">DeltaV specification</a>.<br/>
            Default value is <code>forbidden</code>.
            </li>
            </ul>
        </section>
        
        <section name="More parameters (web.xml)">
            <p>
            There exist some servlet init parameters in the webapp deployment descriptor, i.e. <code>WEB-INF/web.xml</code>
            in the webapp directory, which influence the version control behavior of the server at the WebDAV level.
            </p>
            <ul>
            <li>
            <i>extendedAllprop</i><br/> (xpath: <font color="blue"><code>/web-app/servlet/init-param[param-name="extendedAllprop"]</code></font>):<br/>
            According to WebDAV DeltaV, ACL and Binding specifications,
            a DAV:allprop PROPFIND should <b>not</b> return any of the properties defined
            in any of those documents.
            For testing purposes, the specified behaviour can be disabled by 
            setting this parameter "true".
            </li>
            </ul>
            <p>
            </p>
        </section>
    </body>
  
</document>

